// Copyright (c) 2010 Andrew Lewis. All rights reserved.
// Use of this source code is governed the license in the LICENSE file.

#ifndef _INCLUDE_COMPUTATIONS_H_
#define _INCLUDE_COMPUTATIONS_H_

#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

#include "data.h"

boolean equal_computation(Computation* left, Computation* right);

void print_computation(Computation* computation);

void delete_computation(Computation* computation);

Computation* clean_computation(Computation* computation, int input_clip_stride, int input_clip_max);

void simplify_computation_plane(computation_plane computations);

void evaluate_computation(Computation* computation, long int* max, long int* min, interval_plane current_estimates);

void minimum_zeros_in_lhs_lsb(Computation* computation, int* current_minimum);

void reverse_computation(INT64* left_max, INT64* left_min, Computation* computation, interval_plane current_estimates, boolean use_union_buffer, interval_plane last_iteration, boolean debug_output);

#endif
