// Copyright (c) 2010 Andrew Lewis. All rights reserved.
// Use of this source code is governed the license in the LICENSE file.
//
// cspace.h: 

#ifndef _INCLUDE_CSPACE_H_
#define _INCLUDE_CSPACE_H_

#ifdef USE_GLOBAL_YCC_TABLE 
#define INVERSE_YCC_RGB_TABLE_FILE_NAME "/anfs/bigdisc/abl26/rjpeg/ycc_rgb_table"
#else
#define INVERSE_YCC_RGB_TABLE_FILE_NAME "/tmp/ycc_rgb_table"
#endif

#define CENTRE_JSAMPLE 128
#define LIST_START_SIZE 4
#define MAX_JSAMPLE 255
#define SCALEBITS 16

#define RIGHT_SHIFT(x,shft) ((x) >> (shft))
#define FIX(x) ((INT32) ((x) * (1L << SCALEBITS) + 0.5))
#define ONE_HALF ((INT32) 1 << (SCALEBITS - 1))

#define SHIFT_Y 16
#define SHIFT_CB 8
#define SHIFT_CR 0

// Returns an array of sets containing all possible YCbCr values which the decompressor maps onto the RGB values provided as input.
set_plane reverse_colour_space_transform(packed_image_data rgb_image, inverse_ycc_rgb_table ycc_rgb_table);

// Loads or generates the colour space conversion look-up table.
inverse_ycc_rgb_table get_inverse_ycc_rgb_table();

// Functions for generating the colour space conversion look-up table
inverse_ycc_rgb_table generate_inverse_ycc_rgb_table(const char* table_file);
void write_UINT32(FILE* file, const UINT32 value);
inverse_ycc_rgb_table load_inverse_ycc_rgb_table(const char* table_file);
UINT32 read_UINT32(FILE* file);

#endif
