#ifndef _INCLUDE_FORWARDOPERATIONS_H_
#define _INCLUDE_FORWARDOPERATIONS_H_

#include "data.h"
#include "computations.h"
#include "cspace.h"

boolean refine_luma_and_chroma(block_interval_component_image_data values, block_interval_component_image_data refined_values, quantization_table luma, quantization_table chroma, interval_component_image_data* spatial_estimate, computation_plane smoothing_computations, inverse_ycc_rgb_table inverse_ycc_rgb_table, packed_image_data image, block_status_summary* y_block_status, block_status_summary* cb_block_status, block_status_summary* cr_block_status, boolean final_pass_output, const char* additional_output_file_name);

void refine_upsampled_chroma(interval_component_image_data downsampled_chroma_estimate, set_plane upsampled_component_planes, computation_plane smoothing_computations);

void output_possibilities(block_interval_component_image_data values, quantization_table luma, quantization_table chroma, interval_component_image_data* spatial_estimate);

UINT64 possibility_count(const interval_plane block_plane, const UINT8 bx, const UINT8 by);

// The maximum number of DCT coefficient block choices we are willing to search.
static const UINT64 possibilities_limit = (1L << 20);

// Macros for the IDCT.
#define CONST_BITS  13
#define PASS1_BITS  2
#define MULTIPLY(var,const) ((var) * (const))
#define FIX_0_298631336  ((INT32)  2446)	/* FIX(0.298631336) */
#define FIX_0_390180644  ((INT32)  3196)	/* FIX(0.390180644) */
#define FIX_0_541196100  ((INT32)  4433)	/* FIX(0.541196100) */
#define FIX_0_765366865  ((INT32)  6270)	/* FIX(0.765366865) */
#define FIX_0_899976223  ((INT32)  7373)	/* FIX(0.899976223) */
#define FIX_1_175875602  ((INT32)  9633)	/* FIX(1.175875602) */
#define FIX_1_501321110  ((INT32)  12299)	/* FIX(1.501321110) */
#define FIX_1_847759065  ((INT32)  15137)	/* FIX(1.847759065) */
#define FIX_1_961570560  ((INT32)  16069)	/* FIX(1.961570560) */
#define FIX_2_053119869  ((INT32)  16819)	/* FIX(2.053119869) */
#define FIX_2_562915447  ((INT32)  20995)	/* FIX(2.562915447) */
#define FIX_3_072711026  ((INT32)  25172)	/* FIX(3.072711026) */
#define RANGE_LIMIT(x) ((x) > 127 ? 255 : ((x) < -128 ? 0 : (((x) + 128))))
#define RANGE_MASK (255 * 4 + 3)
#define DESCALE(x,n)  (((x) + (((INT32)1) << ((n)-1))) >> (n))

#endif
